<?php

namespace MotaRaido\Core\Database;

if (!defined('MOTAFW')) 
{
    echo 'This file can only be called via the main index.php file, and not directly';
    exit();
}

use \PDO;
use \Closure;

class Connector extends PDO
{
    private $forcedRollBack = false;

    public function __construct($config) {
        parent::__construct($config['driver'] . ':dbname=' . $config['db'] . ';' . 'host=' . $config['host'], $config['username'], $config['password']);
    }

    public function createTransaction(Closure $func)
    {
        $this->beginTransaction();
        try
        {
            $func($this);
            if ($this->forcedRollBack)
            {
                $this->rollback();
            }
            else
            {
                $this->commit();
            }
        } 
        catch (Exception $e)
        {
            $this->rollback();
            throw $e;
        }
    }

    public function forceRollback()
    {
        $this->forcedRollback = true;
    }
}